function output_new = AdjustedInertias( output, N,  M, Q )

output_new=output;
[tmp1,tmp2]=size(M);
Q=max([tmp1; tmp2]);
clear tmp1 tmp2;

%Size of N
[I,J]=size(N);
%vectors of ones
Ir = ones(I,1);
Ic = ones(J,1);
n=Ir'*N*Ic;
P = (1/n) * N;
r  = P * Ic ;
Dr = diag(r);
c  = (Ir' * P)';
Dc = diag(c);
RP = Dr^(-1) * P;
CP = P * Dc^(-1);
K = J-Q;
A =  Dr^(-1/2) * (P - r * c') * Dc^(-1/2);
%[U,L,V] = svd(A);
[V,L2]=eigs(A*A', K);
L=L2^.5;
U=A*V*inv(L);
chis = Ir'* (A.*A) * Ic * n;
ti = chis/n;

realevals_adj= (Q/(Q-1))^2*(diag(L)-1/Q).^2;
L_adj = sqrt(diag(realevals_adj));

% MAX DIMENSIONS IN THE ANALYSIS (MCA ADJUSTED)
for i=1:J-Q,
    if (L(i,i)<(1/Q)),
        K=i-1;
        break;
    end;
end;

if K<(J-Q),
    %Adjusted inertias for computings (L_a) and output (L_adj)
    L_a = L_adj;
    for i=(K+1):(J-Q),
        L_a(i,i)=0;
    end;
    L_adj=L_adj(1:K,1:K);
else,
    K=J-Q;
end;

% Calculate averaged off diagonal inertia
%
% 
off_dia_i = Q/(Q-1)*(ti-(J-Q)/Q^2);
output_new.ti_adj = off_dia_i; 

% Adjusted eigenvalues
api_adj = [];tmp=0;
for i=1:K,
    tmp = tmp + L_adj(i,i)*L_adj(i,i)/off_dia_i;
    api_adj = [api_adj; tmp];
end;
output_new.eig_adj = [diag(L_adj.*L_adj) diag(L_adj.*L_adj / off_dia_i) api_adj] ;      % Principal inertias adjusted [Raw Percentage Acumulate_percentage]
output_new.aev_adj = 100/K;

end

