function output=JCA (N,M,K)

%output.B          Adjusted Burt matrix
%output.si         Contributions of each variable to total inertia 
%output.i_total    Inertia in the modified Burt matrix
%output.i_dia      Inertia in the modified Burt matrix due to diagonal tables
%output.i_offdia   Inertia in the modified Burt matrix due to off-diagonal tables

C=N;

[tmp1,tmp2]=size(M);
Q=max([tmp1; tmp2]);
clear tmp1 tmp2;

%Size or N
[I,J]=size(N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% CA
%vectors of ones
Ir = ones(I,1);
Ic = ones(J,1);

    
%grand total
n=Ir'*C*Ic;

f=2;fold = f*100;
%while f ~= fold,
for h=1:20,
    
%correspondence matrix P
P = (1/n) * C;

%row masses
r  = P * Ic ;
Dr = diag(r);

%column masses
c  = (Ir' * P)';
Dc = diag(c);

%Rows profiles
RP = Dr^(-1) * P;

%Columns profiles
CP = P * Dc^(-1);

% Standarized residuals
%
% A = Dr^(1/2) * (Dr^(-1) * P - Ir * c') * Dc^(-1/2) = Dr^(-1/2) * (P - r * c') * Dc^(-1/2);  aij = sqrt( (pij - ricj)^2 /ricj ) =(pij - ricj)/sqrt(ricj)
% Chi-square distances
%
A =  Dr^(-1/2) * (P - r * c') * Dc^(-1/2);

%
% SVD of A = U*L*V'

[U,L,V] = svd(A);
L=L(1:K,1:K);
U=U(:,1:K);
V=V(:,1:K);

% Principal coordinates
% 
F = Dr^(-1/2) * U*L;
% Standard coordinates of rows
%
% X = F * L^(-1) = Dr^(-1/2) * U * L * L^(-1) = Dr^(-1/2) * U  
%
X = Dr^(-1/2) * U ;

Cr = n * Dr*(1 + X*L*X')*Dc;

fold=f;f=0;
for q=1:Q,
    last_i  =sum(M(1:q));
    first_i = last_i - M(q) + 1;
    for i=first_i:last_i,
        for j=first_i:last_i,
%            C(i,j)=round(Cr(i,j));
%            f = f + C(i,j);
             C(i,j)=Cr(i,j);
             f = f + C(i,j);
        end;
    end;
end;

end;
si=InertiaContributionSubmatrices(C,M);

output.B = C;
output.si=si;
output.i_total = sum(sum(si)');
output.i_dia = trace(si);
output.i_offdia = sum(sum(si)')-trace(si);

return